import { ComponentType } from 'react';
import '@synerise/ds-core/dist/js/style';
import './style/index.less';
import { DropDownProps as AntDropDownProps, DropdownButtonProps } from 'antd/lib/dropdown';
import SearchBar from '@synerise/ds-search-bar/';
import BottomAction from './elements/BottomAction/BottomAction';
import BackAction from './elements/BackAction/BackAction';
import { Wrapper } from './Dropdown.styles';
import TextTrigger from './elements/TextTrigger/TextTrigger';
export type DropdownProps = AntDropDownProps & {
    destroyPopupOnHide?: boolean;
    hideOnItemClick?: string | boolean;
};
type DropdownButtonType = ComponentType<DropdownButtonProps>;
type SubComponents = {
    Wrapper: typeof Wrapper;
    SearchInput: typeof SearchBar;
    BottomAction: typeof BottomAction;
    BackAction: typeof BackAction;
    Button: DropdownButtonType;
    TextTrigger: typeof TextTrigger;
};
declare const Dropdown: ComponentType<DropdownProps> & SubComponents;
export default Dropdown;
