var _excluded = ["hideOnItemClick", "placement", "dropdownRender", "visible", "open", "onVisibleChange", "onOpenChange", "overlay"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React, { useState, useRef, useCallback, useEffect } from 'react';
import '@synerise/ds-core/dist/js/style';
import "./style/index.css";
import AntdDropdown from 'antd/lib/dropdown';
import SearchBar from '@synerise/ds-search-bar/';
import { getPopupContainer } from '@synerise/ds-utils';
import BottomAction from './elements/BottomAction/BottomAction';
import BackAction from './elements/BackAction/BackAction';
import { Wrapper, OverlayWrapper } from './Dropdown.styles';
import TextTrigger from './elements/TextTrigger/TextTrigger';
var topPlacements = ['topLeft', 'topRight', 'topCenter'];
var Dropdown = function Dropdown(_ref) {
  var hideOnItemClick = _ref.hideOnItemClick,
    placement = _ref.placement,
    dropdownRender = _ref.dropdownRender,
    visible = _ref.visible,
    open = _ref.open,
    onVisibleChange = _ref.onVisibleChange,
    onOpenChange = _ref.onOpenChange,
    overlay = _ref.overlay,
    rest = _objectWithoutPropertiesLoose(_ref, _excluded);
  var openMerged = open !== undefined ? open : visible;
  var onOpenChangeMerged = onOpenChange !== undefined ? onOpenChange : onVisibleChange;
  var _useState = useState(openMerged || false),
    isOpen = _useState[0],
    setIsOpen = _useState[1];
  var overlayWrapperRef = useRef(null);
  useEffect(function () {
    openMerged !== undefined && setIsOpen(openMerged);
  }, [openMerged]);
  var handleOpenChange = function handleOpenChange(newIsOpen) {
    onOpenChangeMerged && onOpenChangeMerged(newIsOpen);
    setIsOpen(newIsOpen);
  };
  var offsetVertical = topPlacements.find(function (topPlacement) {
    return topPlacement === placement;
  }) !== undefined ? -8 : 8;
  var renderContent = useCallback(function (originNode) {
    if (overlay) {
      return typeof overlay === 'function' ? overlay() : overlay;
    }
    return dropdownRender && dropdownRender(originNode);
  }, [dropdownRender, overlay]);
  var renderOverlay = useCallback(function (originNode) {
    return /*#__PURE__*/React.createElement(OverlayWrapper, {
      ref: overlayWrapperRef
    }, renderContent(originNode));
  }, [renderContent]);
  useEffect(function () {
    var handleOverlayClick = function handleOverlayClick(event) {
      if (overlayWrapperRef.current && hideOnItemClick && event.target instanceof HTMLElement) {
        var itemSelector = typeof hideOnItemClick === 'string' ? hideOnItemClick : '[role="menuitem"]';
        var listItem = event.target.closest(itemSelector);
        if (overlayWrapperRef.current.contains(listItem)) {
          setIsOpen(false);
        }
      }
    };
    var overlayNode = overlayWrapperRef.current;
    overlayNode && overlayNode.addEventListener('click', handleOverlayClick);
    return function () {
      overlayNode && overlayNode.removeEventListener('click', handleOverlayClick);
    };
  });
  return /*#__PURE__*/React.createElement(AntdDropdown, _extends({
    getPopupContainer: getPopupContainer,
    align: {
      offset: [0, offsetVertical]
    },
    trigger: ['click'],
    open: isOpen,
    onOpenChange: handleOpenChange,
    dropdownRender: renderOverlay,
    placement: placement
  }, rest));
};
Dropdown.Wrapper = Wrapper;
Dropdown.SearchInput = SearchBar;
Dropdown.BottomAction = BottomAction;
Dropdown.BackAction = BackAction;
Dropdown.Button = AntdDropdown.Button;
Dropdown.TextTrigger = TextTrigger;
export default Dropdown;