import React from 'react';
import Icon, { AngleDownS } from '@synerise/ds-icon';
import { Title } from '@synerise/ds-typography';
import { theme } from '@synerise/ds-core';
import * as S from './TextTrigger.styles';
var TextTrigger = function TextTrigger(_ref) {
  var value = _ref.value,
    expanded = _ref.expanded,
    size = _ref.size,
    _ref$inactiveColor = _ref.inactiveColor,
    inactiveColor = _ref$inactiveColor === void 0 ? 'grey-800' : _ref$inactiveColor,
    onClick = _ref.onClick,
    onFocus = _ref.onFocus,
    _ref$isDisabled = _ref.isDisabled,
    isDisabled = _ref$isDisabled === void 0 ? false : _ref$isDisabled;
  return /*#__PURE__*/React.createElement(S.TextTrigger, {
    onFocus: isDisabled ? undefined : onFocus,
    inactiveColor: theme.palette[inactiveColor],
    tabIndex: 0,
    onClick: isDisabled ? undefined : onClick,
    isDisabled: isDisabled
  }, /*#__PURE__*/React.createElement(Title, {
    level: size
  }, value), /*#__PURE__*/React.createElement(S.IconWrapper, {
    expanded: expanded
  }, /*#__PURE__*/React.createElement(Icon, {
    component: /*#__PURE__*/React.createElement(AngleDownS, null)
  })));
};
export default TextTrigger;